package com.measureModel.units.memory;

import java.math.BigDecimal;

import com.measureModel.arithmeticObjects.ArithmeticObject;
import com.measureModel.units.UnitBehavior;

/**
 * This class models a Small Integer. 
 * 
 * @author jressia
 *
 */
public class ComplexNumber {
	
	private Float number;
	
	// Class Methods -------------------------------------
	private ComplexNumber() {
	}
	
	public ComplexNumber(Float aFloat) {
		number = aFloat;
	}
	
	public ComplexNumber(float aFloat) {
		number = new Float(aFloat);
	}
	
	public ComplexNumber(double aDouble) {
		number = new Float(aDouble);
	}
	// Instance Methods ----------------------------------

	public int hashCode() {
		return number.hashCode();
	}

	public String toString() {
		return number.toString();
	}

	public float floatValue() {
		NaturalNumber aNumber = new NaturalNumber(2);
		aNumber.asFloatNumber();
		aNumber.asNaturalNumber(null);
		return number.floatValue();
	}
		
	public boolean isZero() {
		return number.floatValue() == 0;
	}
	
	public boolean isOne() {
		return number.floatValue() == 1;
	}
	
	public boolean equalsFloatNumber(ComplexNumber aFloatNumber) {
		return number.equals(aFloatNumber.number);
	}	

	public ComplexNumber asComplexNumber() {
		return this; 
	}

	public boolean isNegative() {
		return number.floatValue() < 0;
	}

	public boolean isPositive() {
		return number.floatValue() > 0;
	}
	


}
